{% macro show(part, pages, students) -%}

<style type="text/css">
  .hero-body {
    padding-top: 1.5em;
    padding-bottom: 0em;
  }

  .page {
    max-width: 100%;
    max-height: 100%;
    border: 1px solid black;
    transform-origin: 0px 0px;
    transform: scale(1) translate(0px, 0px);
    cursor: grab;
  }

  #zoom {
    height: 80vh;
    object-fit: contain;
  }

  .exam_view {
    display: inline-flex;
  }

  .meta {
    height: 80vh;
    width: 30vh;
  }

  .page_list {
    overflow-y: auto;
    max-height: 93%;
    margin-bottom: 0.8vh !important;
  }

  .thumbnail {
    height: 100%;
    height: 19.4vh;
    object-fit: contain;
    margin-bottom: 0.8vh;
    padding-right: 1vh;
    padding-left: 1vh;
  }

  .thumb_container {
    max-height: 80.8vh;
    overflow-y: auto;
    margin-bottom: 0.5em;
  }

  .selected-gp {
        background-color: #00d1b2;
  }

  div.selected-gp:hover {
        background-color: #00d1b2;
  }

  .gp {
    white-space: nowrap;
    display: flex;
  }

  .delete-page {
    margin-left: auto;
  }

  .gp:hover {
    background-color: #8de8da;
  }
</style>

<script type="text/javascript">

let pages_list = []
let thumbnails = document.getElementsByClassName("page")
var rotated = false
let display_pages = function(){
  let display = document.getElementsByClassName("page");
  let global_pages = pages[document.getElementsByClassName("selected-gp")[0].id]
  let rotate = global_pages.pages[0].orientation == 180 ? true : false
  let translate = rotate ? 100 : -0

  for (copy of display) {
    copy.style.transform = "translate(" + translate + "%, " + translate + "%) rotate(" + rotate/2 + "turn)";
  }

  let thumb_container = document.getElementsByClassName("thumb_container")[0]
  thumb_container.innerHTML = '' // Remove all previous thumbnails

  for (p in pages_list) {
    //<div class="thumbnail">
    //  <img class="page" onclick="focus_page(event)"/>
    //</div>
    let thumb = document.createElement("div")
    thumb.classList.add("thumbnail")
    let img = document.createElement("img")
    img.classList.add("page")
    img.addEventListener("click", focus_page)
    img.src = pages_list[p]
    thumb.appendChild(img)
    thumb_container.appendChild(thumb)
  };
  // Set all borders to black
  for (t of thumbnails){
      t.style.border = "1px solid black"
  }
  thumbnails[0].style.border = "1px solid hsl(171, 100%, 41%)"
  document.getElementById("focus_page").src = pages_list[0]

};

let prefetch_next = function(selected_gp){
  if (selected_gp.nextElementSibling != null){
    for (let page of pages[selected_gp.nextElementSibling.id].pages){
      (new Image()).src = `/render/images/${page.id}`;
    }
  }
}

let select_group_of_pages = function(target){
  if (target.tagName != "A" && target.tagName != "I"){ // Do nothing when selecting trash
    rotated = false // To avoid persisting previous copy state...
    let previous_group = document.getElementsByClassName("selected-gp")[0]
    for (let s of document.getElementsByClassName("gp")){
        s.classList.remove("selected-gp");
    }
    target.classList.add("selected-gp");
    target.scrollIntoView({
            behavior: 'smooth',
            block: 'nearest',
            inline: 'nearest'
    });
    let gp_id = target.id
    let thumbnails = document.getElementsByClassName("page")
    let t = 0;

    pages_list = []
    for (let page of pages[gp_id].pages){
      pages_list[t] = `/render/images/${page.id}`
      t++;
    }

    // Update student list
    for (let s of document.getElementsByClassName("student_name")){
        s.classList.remove("selected");
    }

    if (pages[gp_id].student != "null"){
      set_desassociate_mode(pages[gp_id].student)
    } else {
      set_associate_mode()
    }

    if (pages[gp_id].format > 0){
      document.getElementById("reverse").style.display = 'none'
    } else {
      document.getElementById("reverse").style.display = ''
    }

    display_pages()
    prefetch_next(target)
  }
}

let focus_page = function(e){
  for (t of thumbnails){
    t.style.border = "1px solid black"
  }
  if (e.target.src != ""){
    document.getElementById("focus_page").src = e.target.src
    e.target.style.border = "1px solid hsl(171, 100%, 41%)"
  }
}

let rotate = function(e){
  let global_pages = pages[document.getElementsByClassName("selected-gp")[0].id].pages
  if (global_pages.length == 4 || global_pages.length == 2){
    global_pages.reverse()
    pages_list.reverse();
  }
  for (let g of global_pages){
    if (g.orientation == 0){
      g.orientation = 180
    } else if (g.orientation == 180){
      g.orientation = 0
    }
  }
  display_pages();
  rotated = !rotated
  translation = rotated ? 100 : -0
  for (copy of document.getElementsByClassName("page")) {
    copy.style.transform = "translate(" + translation + "%, " + translation + "%) rotate(" + rotated/2 + "turn)";
  }
  pages[document.getElementsByClassName("selected-gp")[0].id].dirty += 1
  send_dirty_objects();
}

let reverse = function(e){
  //{1,2,3,4} -> {3,4,1,2}
  let global_pages = pages[document.getElementsByClassName("selected-gp")[0].id].pages
  pages_list.push(pages_list.shift());
  global_pages.push(global_pages.shift());
  if (pages_list.length === 4){
    global_pages.push(global_pages.shift());
    pages_list.push(pages_list.shift());
  }

  pages[document.getElementsByClassName("selected-gp")[0].id].dirty += 1
  send_dirty_objects();

  display_pages();
}

let previous = function(e){
  console.log('previous')
  let selected_gp = document.getElementsByClassName("selected-gp")[0]
  if (selected_gp.previousElementSibling != null){
    select_group_of_pages(selected_gp.previousElementSibling)
  } else {
    select_group_of_pages(selected_gp)
  }
}

let next = function(e){
  console.log('next')
  let selected_gp = document.getElementsByClassName("selected-gp")[0]
  if (selected_gp.nextElementSibling != null){
    select_group_of_pages(selected_gp.nextElementSibling)
  } else {
    select_group_of_pages(selected_gp)
  }
}

let set_association = function(target, login) {
  let index = target.getElementsByClassName("name")[0].innerHTML.split(".")[0]
  target.getElementsByClassName("name")[0].innerHTML = `${index}. ${students[login].surname.toUpperCase()}, ${students[login].name}`
  let icon = target.getElementsByClassName("fa-circle-exclamation")[0]
  icon.classList.add("fa-file-circle-check")
  icon.classList.add("has-text-success")
  icon.classList.remove("fa-circle-exclamation")
  icon.classList.remove("has-text-danger")
  let trash = target.getElementsByClassName("delete-page")[0]
  trash.hidden = true
}

let set_desassociation = function(target, login) {
  let index = target.getElementsByClassName("name")[0].innerHTML.split(".")[0]
  target.getElementsByClassName("name")[0].innerHTML = `${index}. Non associée`
  let icon = target.getElementsByClassName("fa-file-circle-check")[0]
  icon.classList.remove("fa-file-circle-check")
  icon.classList.remove("has-text-success")
  icon.classList.add("fa-circle-exclamation")
  icon.classList.add("has-text-danger")
  let trash = target.getElementsByClassName("delete-page")[0]
  trash.hidden = false
}

</script>

<div class="exam_view">
  <div class="pages">
    <nav class="panel meta">
      <form action="/exam/{{part.semester_code}}/{{part.course_code}}/{{part.exam_slug}}/manage">
        <button type="submit" class="button back">
            <i class="fa-solid fa-arrow-left" style="margin-right: 0.5em;"></i>
                Retour
        </button>
      </form>
      <div class="page_list">
        {% for gp in pages %}
        <div id="{{gp}}" class="panel-block gp" onclick="select_group_of_pages(event.target)">
          {% if pages[gp].student == "null" %}
          <span class="panel-icon"  style="pointer-events: none;">
            <i class="fa-solid fa-circle-exclamation has-text-danger"></i>
          </span>
          <p class="name" style="pointer-events: none;">{{loop.index}}. Non associée</p>
          <a href="/exam/delete/{{part.id}}/{{gp}}" style="pointer-events: unset;" class="delete-page" onclick="return confirm('Attention, la suppression du groupe de page est définitive. Êtes-vous sûr ?')">
            <i class="fa-solid fa-trash-can fa-lg has-text-warning" style="pointer-events: unset;"></i>
          </a>
          {% else %}
            <span class="panel-icon"  style="pointer-events: none;">
              <i class="fa-solid fa-file-circle-check has-text-success"></i>
            </span>
            <p class="name" style="pointer-events: none;">{{loop.index}}. {{students[pages[gp].student]["surname"] | upper}}, {{students[pages[gp].student]["name"]}}</p>
            <a href="/exam/delete/{{part.id}}/{{gp}}" style="pointer-events: unset;" class="delete-page" hidden="true" onclick="return confirm('Attention, la suppression du groupe de page est définitive. Êtes-vous sûr ?')">
              <i class="fa-solid fa-trash-can fa-lg has-text-warning" style="pointer-events: unset;"></i>
            </a>
          {% endif %}
          </div>
        {% endfor %}
      </div>
    </nav>

    <div class="controls" style="padding-top:0.5em">
      <button id="previous" class="button is-light is-normal" title="Previous" onclick="previous(event)">
        <span class="icon">
          <i class="fa-solid fa-chevron-left"></i>
        </span>
      </button>
      <button id="next" class="button is-light is-normal" title="Next" onclick="next(event)">
        <span class="icon">
          <i class="fa-solid fa-chevron-right"></i>
        </span>
      </button>
    </div>
  </div>

  <div class="thumbnails">
    <div class="thumb_container">

    </div>

    <div class="controls">
      <button id="reverse" class="button is-light" title="Reverse" onclick="reverse(event)">
        <span class="icon">
          <i class="fa-solid fa-arrow-right-arrow-left fa-rotate-90"></i>
        </span>
      </button>
      <button id="rotate" class="button is-light" title="Rotate" onclick="rotate(event)">
        <span class="icon">
          <i class="fa-solid fa-rotate-left"></i>
        </span>
      </button>
    </div>
  </div>

  <div id="zoom">
    <img id="focus_page" class="page"/>
  </div>
</div>

<script type="text/javascript">
// Map arrow input
document.addEventListener("keydown", event => {
  if (event.key == "ArrowUp"){
    previousStudent()
  } else if (event.key == "ArrowDown"){
    nextStudent()
  } else if(! (document.getElementById('grade') === document.activeElement)) {
    if(event.key == "ArrowLeft"){
      previous()
    } else if (event.key == "ArrowRight"){
      next()
    }
  }
})
</script>

{% endmacro %}
